from asc.core import log
from asc.core.ABC.Control import ControlTool
from asc.tools.mailer.core import Mailer
from asc.models.mailer import MailerMail


class ControlToolHandler(ControlTool):

    def __init__(self):
        super(ControlToolHandler, self).__init__()
        self.__ML = Mailer()

    def send_mail(self, to, slug, subject, html_vars, **props):
        log.debug(f'html_vars {str(dict(html_vars))}')

        mail_sent = self.__ML.send_mail_slug(
            to=to,
            slug=slug,
            subject=subject,
            html_vars=html_vars
        )

        mail = MailerMail()
        mail.slug = slug
        mail.data_vars = html_vars
        mail.id_marketplace_client = props.get('id_client')
        self.session.add(mail)
        self.commit()