from enum import Enum
from decimal import Decimal


class PaymentGateway(Enum):
    """ Gateway de pagamento. """
    pagarme = 1
    mercadopago = 2

    def get_amount(self, amount):
        """
        Obtém valor de pagamento
        no padrão aceito pelo gateway.
        :param amount:
        :return:
        """
        print(self)
        print(type(self))
        if self == PaymentGateway.pagarme:
            if type(amount) in [float, Decimal]:
                return round(amount * 100)

        return amount


class PaymentMethod(Enum):
    """ Método de pagamento. """
    bank_slip = 1
    bank_transfer = 2
    card = 3
    pix = 4


class PaymentStatus(Enum):
    """ Status para pagamentos. """
    pending = 1  # Pagamento inicializado.
    init = 1  # Pagamento inicializado.
    waiting_payment = 2  # Aguardando pagamento.
    recusado = 3  # Pagamento recusado.
    refused = 3  # Pagarme - Pagamento recusado.
    rejected = 3  # Mercadopago - Pagamento recusado.
    aprovado = 4  # Pagamento aprovado.
    paid = 4  # Pagarme - Pagamento aprovado.
    approved = 4  # Mercadopago - Pagamento aprovado.
    refunded = 8 # Pagamento extornado.
    expirado = 6 # Pagamento expirado.
    cancelled = 6  # Mercadopago - Pagamento expirado.


class ProcessType(Enum):
    """ Tipo de valor para processamento. """
    fix = 1
    percentage = 2


class OrderStatus(Enum):
    """ Status para pedidos. """
    recebido = 1  # Pedido recebido com sucesso.
    pending = 1  # Mercadopago - Pedido recebido com sucesso.
    pagamento_aprovado = 2  # Pagamento foi confirmado.
    approved = 2  # Mercadopago - Pagamento confirmado.
    em_separacao = 3  # Separando itens do pedido.
    em_transporte = 4  # Pedido sendo entregue ao destino.
    pedido_entregue = 5  # Pedido foi entregue.
    recusado = 6  # Pedido foi recusado.
    rejected = 6  # Mercadopago - Pedido recusado.
    cancelled = 6  # Mercadopago - Pedido cancelado.
    em_andamento = 7  # Pedido acabou de ser criado no sistema.
    refunded = 8  # Pagamento extornado.
